<?php


namespace WPEasyTranslate\View;


use WPEasyTranslate\Service\Language;
use MetatickPluginLib\View\TemplateResponseTrait;
use MetatickPluginLib\View\ViewBase;
use WPEasyTranslate\Plugin;

class Footer extends ViewBase
{
    use TemplateResponseTrait;

    protected $template = 'footer.html';

    public function __construct($template_path)
    {
        parent::__construct($template_path);
        if(Plugin::settings()->enabled) {
            add_action('wp_footer', [$this, 'render']);
        }
    }

    public function get_context(){
        return [
            'settings' => Plugin::settings(),
            'languages' => Language::selected_as_array(),
            'language' => Language::site_language(),
            'plugin' => Plugin::instance()
        ];
    }

    public function render(){
        $response = $this->get();
        echo $response->get_body();
    }
}