<?php

namespace MetatickPluginLib\Model;


class PostMetaModel extends Model {
    protected $meta_key = '';
    public $post_id = -1;

    public function __construct($post_id)
    {
        $this->initialize(static::META_KEY, $post_id);
    }

    public function initialize($meta_key, $post_id) {
        $this->meta_key = $meta_key;
        $this->post_id  = $post_id;

        $this->properties = get_post_meta($this->post_id, $this->meta_key, true);
        if ($this->properties == null) {
            $this->properties = [];
        }
    }

    public function save() {
        update_post_meta($this->post_id, $this->meta_key, $this->properties);
    }
}