<?php


namespace MetatickPluginLib\View;


use MetatickPluginLib\Http\HttpResponseRedirect;
use MetatickPluginLib\Http\TemplateResponse;
use MetatickPluginLib\Request\Request;

trait UpdateObjectTrait
{
    public function save(){
        $object = $this->get_object();
        $request = Request::instance();
        foreach(static::$fields as $key => $type) {
            if(method_exists($this, "get_$key")){
                $value = call_user_func_array([$this, "get_$key"], [$request]);
            }else {
                $value = $request->POST()->get($key);
            }

            if($type === static::CHECK){
                $object->$key = !!$value;
            }else if($value !== null) {
                $object->$key = $value;
            }
        }
        $object->save();
        return true;
    }

    public function success(){
        $this->add_message('success', 'Changes Saved');
        $request = Request::instance();
        return new HttpResponseRedirect($request->url());
    }

    public function failure(){
        return $this->get();
    }

    public function post(){
        $this->validate_csrf();

        if($this->save()){
            return $this->success();
        }
        return $this->failure();
    }
}